/*
    Copyright (C) 2001, 2002 Stephane Magnenat
    for any question or comment contact us at nct@ysagoon.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. | See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA | 02111-1307 | USA
*/

#ifndef __SPLINEHIGHMAP_H
#define __SPLINEHIGHMAP_H

#include <memory.h>

	/// Spline highmap
class SplineHeightMap
{
public:
	SplineHeightMap() { highmap=0; }
	~SplineHeightMap() { cleanup(); }
	void Reset(int maskw,int maskh);
	bool Load(char *filename) { return false; }
	bool Save(char *filename) { return false; }
	float GetH(float x, float y);
	float GetCP(int x,int y) { return highmap[(x&mapwmask)+(y&maphmask)*mapw]; }
	//void GetCP4(int x,int y, float &f0, float &f1, float &f2, float &f3);
	void SetCP(int x,int y,float z) { highmap[(x&mapwmask)+(y&maphmask)*mapw]=z; }
	int GetMapW(void) { return mapw; }
	int GetMapH(void) { return maph; }
private:
	float Evaluate(float u, float v, int x, int y);
	void cleanup(void) { if (highmap) delete highmap; }
private:
	float *highmap;
	int mapw,maph;
	int mapwmask,maphmask;
};

#endif
